#include "core/ToString.h"

#include <stdarg.h>
#include <stdio.h>

size_t toString(char* buffer, size_t n, const char* format, ...) {
    va_list args;
    va_start(args, format);
    int w = vsnprintf(buffer, n, format, args);
    va_end(args);
    return w < 0 ? 0 : (size_t)w;
}

size_t toStringSize(const size_t* p, char* buffer, size_t n) {
    return toString(buffer, n, "%zu", *p);
}

size_t toStringInt(const int* p, char* buffer, size_t n) {
    return toString(buffer, n, "%d", *p);
}

void stringAdd(size_t* w, char** buffer, size_t* n, size_t shift) {
    *w += shift;
    if(*n > shift) {
        *buffer += shift;
        *n -= shift;
    } else {
        *n = 0;
    }
}
